class Wheel {
   PShape wheel;
   float rotation;
   float scaleFactor;
   
   Wheel(String filename){
     this.wheel = loadShape(filename);
     this.rotation = 0.0;
     this.scaleFactor = 1.0;
   }
   
   // Some value to just look somewhat reasonable
   void addRotation(){
     this.rotation += 0.05;
   }
   
   void drawAt(float x, float y){
     pushMatrix();
     translate(x, y);
     rotate(rotation);
     scale(this.scaleFactor);
     
     /* Draw the shape so that the center is at the translated
        origin. This makes it easy to spin the wheel about its
        axis instead of the default behavior, which spins it
        about the upper left corner of the bounding box */
     shapeMode(CENTER);
     shape(wheel, 0, 0);
     popMatrix();
   }
  
}
