class Bicycle {
  // Values determined by experiment
  static final float WHEEL_Y = 117;
  static final float FRONT_WHEEL_X = 240;
  static final float BACK_WHEEL_X = -240;
  static final float SCALE = 0.4;
  
  PShape frame;
  Wheel wheel;
  float x, y, speed;
  
  boolean isAttached = false;

  Bicycle(String frameSVG, String wheelSVG, float initX){
    this(frameSVG, wheelSVG, initX, 120);
  }
  
  Bicycle(String frameSVG, String wheelSVG, float initX, float initY){
     this.frame = loadShape(frameSVG);
     this.wheel = new Wheel(wheelSVG);
     this.y = initY;
     this.x = initX;
     this.speed = 1;
     this.isAttached = false;
  }
  
  void draw(){
    if(isAttached){
      // Drawing when attached should be handled by the Truck
      return;
    }
    forceDraw();
  }
  
  void forceDraw(){
    pushMatrix();
    translate(x, y);
    scale(SCALE);
 
    // Wheelie angle: -PI/6
    rotate(-PI/6);
 
    wheel.drawAt(FRONT_WHEEL_X, WHEEL_Y);
    wheel.drawAt(BACK_WHEEL_X, WHEEL_Y);
    shape(this.frame, 0, 0);
    popMatrix(); 
  }
  
   void move(){
     this.x += speed;
     this.wheel.addRotation();
   }
   
   void attachTo(Truck t){
     this.x = -230;
     this.y = -100;
     this.speed = 0.4;
     t.attached = this;
     this.isAttached = true;
   }
   
   void detachFrom(Truck t){
     assert t.attached == this;
     t.attached = null;
     this.isAttached = false;
   }
  
}
