/// A road class which is drawn at a certain y-position on the
/// screen and stretches all the way across
class Road {
   float ypos, h;
   static final float STRIPE_LEN = 50;
   
   Road(float ypos, float h){
     this.ypos = ypos;
     this.h = h;
   }
   
   void draw(){
     pushMatrix();
     translate(0, ypos);
     shearX(-PI/4);
     
     // Draw the primary road bed
     fill(#272727);
     rectMode(RADIUS);
     rect(0, 0, width, this.h/2);
     
     // Draw the centerline
     fill(#F0F723);
     rectMode(CENTER);
     for(float i = -width; i < width; i += STRIPE_LEN){
       rect(i, 0, STRIPE_LEN/1.5, this.h/15);
     }
     
     popMatrix();
   }
   
}
