class Truck {
  // Values determined by experiment
  static final float WHEEL_Y = 93;
  static final float FRONT_WHEEL_X = 356;
  static final float BACK_WHEEL_X = -297;
  static final float SCALE = 0.4;
  
  PShape body;
  Wheel wheel;
  float x, y, speed;
  
  Bicycle attached;

  Truck(String bodySVG, String wheelSVG, float initX){
    this.body = loadShape(bodySVG);
    this.wheel = new Wheel(wheelSVG);
    this.wheel.scaleFactor = 0.13;
    this.x = initX;
    this.y = 0; // Determined by experiment
    this.speed = 2;
    attached = null;
  }
  
  void draw(){
    pushMatrix();
    translate(x, y);

    // Wheelie angle: -PI/10
    
    if (this.attached != null){
      this.attached.forceDraw();
    }
    
    // Truck body is flipped left-right, so unflip it.
    // but don't maintain the mirror after that or things
    // get really confusing.
    pushMatrix();
    scale(-1.0, 1.0);
    shape(this.body, 0, 0);
    popMatrix();
    
    wheel.drawAt(FRONT_WHEEL_X, WHEEL_Y);
    wheel.drawAt(BACK_WHEEL_X, WHEEL_Y);
    popMatrix();
  }
  
   void move(){
     this.x += speed;
     this.wheel.addRotation();
   }
  
}
